unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, ComCtrls, OleCtrls, Buttons, ToolWin, Isp3,
  PreviewHTML;


type
  TMainForm = class(TForm)
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    View1: TMenuItem;
    DocumentSource1: TMenuItem;
    NavigatorImages: TImageList;
    NavigatorHotImages: TImageList;
    LinksImages: TImageList;
    LinksHotImages: TImageList;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    BackBtn: TToolButton;
    ForwardBtn: TToolButton;
    StopBtn: TToolButton;
    RefreshBtn: TToolButton;
    ToolBar2: TToolBar;
    ToolButton6: TToolButton;
    ToolButton5: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    Animate1: TAnimate;
    URLs: TComboBox;
    Help1: TMenuItem;
    About1: TMenuItem;
    N1: TMenuItem;
    Toolbar3: TMenuItem;
    Statusbar2: TMenuItem;
    Home: TToolButton;
    FontZoom: TToolButton;
    Open1: TMenuItem;
    N2: TMenuItem;
    PreviewHTML1: TPreviewHTML;
    ToolButton1: TToolButton;
    OpenDialog1: TOpenDialog;
    Help: TToolButton;
    Help2: TMenuItem;
    N3: TMenuItem;
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
 //   procedure DocumentSource1Click(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure URLsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure LinksClick(Sender: TObject);
    procedure RefreshBtnClick(Sender: TObject);
    procedure BackBtnClick(Sender: TObject);
    procedure ForwardBtnClick(Sender: TObject);
    procedure URLsClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Toolbar3Click(Sender: TObject);
    procedure Statusbar2Click(Sender: TObject);
    procedure HomeClick(Sender: TObject);
    procedure FontZoomClick(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure PreviewHTML1StatusBusyChange(Sender: TObject;
      const Busy: Boolean);
    procedure PreviewHTML1AfterNavigate(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure DocumentSource1Click(Sender: TObject);
    procedure HelpClick(Sender: TObject);
  private
    UpdateCombo: Boolean;
    Backtimes,Forwardtimes:integer;
  end;

var
  MainForm: TMainForm;

implementation

uses DocSrc, About;

{$R *.DFM}

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
  ShowAboutBox;
end;

procedure TMainForm.DocumentSource1Click(Sender: TObject);
begin

  with DocSourceFrm do
  begin
    Show;
    Memo1.Lines.Clear;
    Memo1.Lines.LoadFromFile(PreviewHTML1.GetLocationName);
    Memo1.SelStart := 0;
    SendMessage(Memo1.Handle, EM_ScrollCaret, 0, 0);
  end;
end;

procedure TMainForm.StopBtnClick(Sender: TObject);
begin
PreViewHTML1.Stop;
end;


procedure TMainForm.URLsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_Return then
  begin
    UpdateCombo := True;
    PreviewHTML1.LoadHTML(URLs.Text);
  end;
end;

procedure TMainForm.URLsClick(Sender: TObject);
begin
  PreviewHTML1.LoadHTML(URLs.Text);
end;

procedure TMainForm.LinksClick(Sender: TObject);
begin
  if (Sender as TToolButton).Hint = '' then Exit;
  URLs.Text := (Sender as TToolButton).Hint;
  PreviewHTML1.LoadHTML(URLs.Text);
end;

procedure TMainForm.RefreshBtnClick(Sender: TObject);
begin
  PreviewHTML1.Refresh;
end;

procedure TMainForm.BackBtnClick(Sender: TObject);
begin
  UpdateCombo:=false;
  PreviewHTML1.GoBack;
  Backtimes:=Backtimes-1;
  Forwardtimes:=Forwardtimes+1;
  ForwardBtn.Enabled:=true;
  If Backtimes=1 then BackBtn.Enabled:=false;
end;

procedure TMainForm.ForwardBtnClick(Sender: TObject);
begin
  UpdateCombo:=false;
  PreviewHTML1.GoForward;
  Backtimes:=Backtimes+1;
   Forwardtimes:=Forwardtimes-1;
   BackBtn.Enabled:=true;
  if Forwardtimes=0 then ForwardBtn.Enabled:=false;
end;


procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Shift = [ssAlt] then
    if (Key = VK_RIGHT) and ForwardBtn.Enabled then
      ForwardBtn.Click
    else if (Key = VK_LEFT) and BackBtn.Enabled then
      BackBtn.Click;
end;

procedure TMainForm.Toolbar3Click(Sender: TObject);
begin
  with Sender as TMenuItem do
  begin
    Checked := not Checked;
    Coolbar1.Visible := Checked;
  end;
end;

procedure TMainForm.Statusbar2Click(Sender: TObject);
begin
  with Sender as TMenuItem do
  begin
    Checked := not Checked;
    StatusBar1.Visible := Checked;
  end;
end;


procedure TMainForm.FormCreate(Sender: TObject);
begin
  BackTimes:=0;
  Forwardtimes:=0;
  Animate1.FileName := ExtractFilePath(Application.ExeName) + 'cool.avi';
end;

procedure TMainForm.HomeClick(Sender: TObject);
begin
PreviewHTMl1.GoHomepage;
end;

procedure TMainForm.FontZoomClick(Sender: TObject);
begin
PreviewHTML1.NextFontZoom;
end;

procedure TMainForm.ToolButton1Click(Sender: TObject);
begin
PreviewHTML1.GoSearchpage;
end;

procedure TMainForm.PreviewHTML1StatusBusyChange(Sender: TObject;
  const Busy: Boolean);
begin
 Animate1.Active:=Busy;
 StopBtn.Enabled:=Busy;
end;

procedure TMainForm.PreviewHTML1AfterNavigate(Sender: TObject);
var
  NewIndex: Integer;
  URL:string;
begin
  URL:=PreviewHTML1.GetLocationURL;
  if UpdateCombo then
  begin
    UpdateCombo := False;
    NewIndex := URLs.Items.IndexOf(URL);
    if NewIndex = -1 then
      begin
      Backtimes:=Backtimes+1;
      URLs.Items.Insert(0, URL);
      end
    else
      URLs.Items.Move(NewIndex, 0);
  end;

  URLs.Text := URL;
  Statusbar1.Panels[0].Text := URL;
  If BackTimes>1 then BackBtn.Enabled:=true;

end;

procedure TMainForm.Open1Click(Sender: TObject);
begin
If OpenDialog1.Execute then begin
UpdateCombo:=true;
PreviewHTMl1.LoadHTML(OpenDialog1.Filename);
DocumentSource1.Enabled:=true;
end;
end;


procedure TMainForm.HelpClick(Sender: TObject);
var HelpFile:String;
begin
 HelpFile := ExtractFilepath(application.exename);
 HelpFile:=Copy(HelpFile,0,length(HelpFile)-6);
 if FileExists(HelpFile+'Document\Eng\Help.html') then
   begin
    HelpFile := HelpFile+'Document\Eng\Help.html';
    PreviewHTML1.LoadHTML(HelpFile);
   end
 else
 if FileExists(HelpFile+'Document\Jap\Help.htm') then
   begin
    HelpFile := HelpFile+'Document\Jap\Help.htm';
    PreviewHTML1.LoadHTML(HelpFile);
   end
   else begin
         ShowMessage('Help file not found');
         exit;
        end;
end;

end.
